module     p0_udbar_neepbbbar_d23h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity0/d23h0l1d.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d23
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd23h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = abb23n17
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb23n26+k2(iv1)*abb23n22+l5(iv1)*abb23n25+l6(iv1)&
         &*abb23n25+spvak2k1(iv1)*abb23n31+spvak2l5(iv1)*abb23n28+spvak2l6(iv1)*&
         &abb23n29+spvak3k1(iv1)*abb23n30+spvak3k2(iv1)*abb23n23+spvak3l5(iv1)*a&
         &bb23n24+spvak3l6(iv1)*abb23n27+spval5k1(iv1)*abb23n19+spval5k2(iv1)*ab&
         &b23n21+spval6k1(iv1)*abb23n18+spval6k2(iv1)*abb23n20)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d23:
   subroutine     reconstruct_d23(coeffs)
      use p0_udbar_neepbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_23:
      coeffs%coeffs_23%c0 = derivative(czip)
      coeffs%coeffs_23%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_23%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_23%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_23%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_23:
   end subroutine reconstruct_d23
!---#] subroutine reconstruct_d23:
end module p0_udbar_neepbbbar_d23h0l1d
