module     p0_udbar_neepbbbar_d26h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity0/d26h0l1.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_udbar_neepbbbar_groups, only: &
!           & sign => diagram26_sign, shift => diagram26_shift
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd26h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d26
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d26 = 0.0_ki
      t1 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t2 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t7 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      d26 = (abb26n1+t1*abb26n11+t2*abb26n11+t3*abb26n12+t4*abb26n13+t5*abb26n20&
      &+abb26n10*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb26n14*(Q(1)*sp&
      &val5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))+abb26n2*(Q(&
      &1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))+abb26n&
      &3*(Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(4))+a&
      &bb26n8*(Q(1)*spval6l5(1)-Q(2)*spval6l5(2)-Q(3)*spval6l5(3)-Q(4)*spval6l5(&
      &4))+abb26n9*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+t1*t6*abb26n15+t1*t&
      &7*abb26n6+t2*t6*abb26n15+t2*t7*abb26n6+t3*t6*abb26n18+t3*t7*abb26n5+t4*t6&
      &*abb26n4+t4*t7*abb26n7+t4*abb26n17*(Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3&
      &)*spvak4k2(3)-Q(4)*spvak4k2(4))+t5*t6*abb26n21+t5*t7*abb26n19+t5*abb26n16&
      &*(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)))
      numerator = cmplx(real(d26, ki), aimag(d26), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd26h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d26
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d26 = 0.0_ki
      t1 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t2 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t7 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      d26 = (abb26n1+t1*abb26n11+t2*abb26n11+t3*abb26n12+t4*abb26n13+t5*abb26n20&
      &+abb26n10*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb26n14*(Q(1)*sp&
      &val5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))+abb26n2*(Q(&
      &1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))+abb26n&
      &3*(Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(4))+a&
      &bb26n8*(Q(1)*spval6l5(1)-Q(2)*spval6l5(2)-Q(3)*spval6l5(3)-Q(4)*spval6l5(&
      &4))+abb26n9*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+t1*t6*abb26n15+t1*t&
      &7*abb26n6+t2*t6*abb26n15+t2*t7*abb26n6+t3*t6*abb26n18+t3*t7*abb26n5+t4*t6&
      &*abb26n4+t4*t7*abb26n7+t4*abb26n17*(Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3&
      &)*spvak4k2(3)-Q(4)*spvak4k2(4))+t5*t6*abb26n21+t5*t7*abb26n19+t5*abb26n16&
      &*(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)))

      numerator = cmplx(real(d26, ki), aimag(d26), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_udbar_neepbbbar_d26h0l1
