module     p0_udbar_neepbbbar_d28h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity0/d28h0l1.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_udbar_neepbbbar_groups, only: &
!           & sign => diagram28_sign, shift => diagram28_shift
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd28h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d28
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k6+k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d28 = 0.0_ki
      t1 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t2 = (Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spval5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))
      t7 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      d28 = (abb28n1+t1*abb28n2+t2*abb28n3+t3*abb28n4+t4*abb28n5+t5*abb28n7+t6*a&
      &bb28n8+abb28n12*(Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*&
      &spval5k1(4))+abb28n6*(Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))+t1*t2*&
      &abb28n14+t2*t5*abb28n11+t3*t6*abb28n9+t3*t7*abb28n10+t4*t6*abb28n13+t4*t7&
      &*abb28n15)
      numerator = cmplx(real(d28, ki), aimag(d28), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd28h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d28
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k6+k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d28 = 0.0_ki
      t1 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t2 = (Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spval5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))
      t7 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      d28 = (abb28n1+t1*abb28n2+t2*abb28n3+t3*abb28n4+t4*abb28n5+t5*abb28n7+t6*a&
      &bb28n8+abb28n12*(Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*&
      &spval5k1(4))+abb28n6*(Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))+t1*t2*&
      &abb28n14+t2*t5*abb28n11+t3*t6*abb28n9+t3*t7*abb28n10+t4*t6*abb28n13+t4*t7&
      &*abb28n15)

      numerator = cmplx(real(d28, ki), aimag(d28), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_udbar_neepbbbar_d28h0l1
