module     p0_udbar_neepbbbar_d12h2l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wpbb/1.4/Virtual/p0
   ! _udbar_neepbbbar/helicity2/d12h2l1.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepbbbar_config, only: ki
   use p0_udbar_neepbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_udbar_neepbbbar_groups, only: &
!           & sign => diagram12_sign, shift => diagram12_shift
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd12h2
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d12
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k6+k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d12 = 0.0_ki
      t1 = (Q(1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      d12 = (abb12n6+t1*abb12n12+t2*abb12n15+t3*abb12n22+t4*abb12n4+abb12n10*(Q(&
      &1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb12n11*(Q(1)*l5(1)-Q(2)*l5(2)-Q(&
      &3)*l5(3)-Q(4)*l5(4))+abb12n11*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4&
      &))+abb12n13*(Q(1)*spvak3l6(1)-Q(2)*spvak3l6(2)-Q(3)*spvak3l6(3)-Q(4)*spva&
      &k3l6(4))+abb12n14*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4&
      &)*spvak3k2(4))+abb12n16*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(&
      &3)-Q(4)*spval6k1(4))+abb12n19*(Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spv&
      &al5k1(3)-Q(4)*spval5k1(4))+abb12n2*(Q(1)*spval5k4(1)-Q(2)*spval5k4(2)-Q(3&
      &)*spval5k4(3)-Q(4)*spval5k4(4))+abb12n7*(Q(1)*spvak2l5(1)-Q(2)*spvak2l5(2&
      &)-Q(3)*spvak2l5(3)-Q(4)*spvak2l5(4))+abb12n8*(Q(1)*spvak3l5(1)-Q(2)*spvak&
      &3l5(2)-Q(3)*spvak3l5(3)-Q(4)*spvak3l5(4))+abb12n9*(Q(1)*spvak2l6(1)-Q(2)*&
      &spvak2l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))+t1*t3*abb12n17+t1*t4*abb12&
      &n3+t1*t5*abb12n20+t2*t3*abb12n18+t2*t4*abb12n5+t2*t5*abb12n21)
      numerator = cmplx(real(d12, ki), aimag(d12), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_udbar_neepbbbar_globalsl1, only: epspow
      use p0_udbar_neepbbbar_kinematics
      use p0_udbar_neepbbbar_abbrevd12h2
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d12
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k6+k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d12 = 0.0_ki
      t1 = (Q(1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      d12 = (abb12n6+t1*abb12n12+t2*abb12n15+t3*abb12n22+t4*abb12n4+abb12n10*(Q(&
      &1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb12n11*(Q(1)*l5(1)-Q(2)*l5(2)-Q(&
      &3)*l5(3)-Q(4)*l5(4))+abb12n11*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4&
      &))+abb12n13*(Q(1)*spvak3l6(1)-Q(2)*spvak3l6(2)-Q(3)*spvak3l6(3)-Q(4)*spva&
      &k3l6(4))+abb12n14*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4&
      &)*spvak3k2(4))+abb12n16*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(&
      &3)-Q(4)*spval6k1(4))+abb12n19*(Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spv&
      &al5k1(3)-Q(4)*spval5k1(4))+abb12n2*(Q(1)*spval5k4(1)-Q(2)*spval5k4(2)-Q(3&
      &)*spval5k4(3)-Q(4)*spval5k4(4))+abb12n7*(Q(1)*spvak2l5(1)-Q(2)*spvak2l5(2&
      &)-Q(3)*spvak2l5(3)-Q(4)*spvak2l5(4))+abb12n8*(Q(1)*spvak3l5(1)-Q(2)*spvak&
      &3l5(2)-Q(3)*spvak3l5(3)-Q(4)*spvak3l5(4))+abb12n9*(Q(1)*spvak2l6(1)-Q(2)*&
      &spvak2l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))+t1*t3*abb12n17+t1*t4*abb12&
      &n3+t1*t5*abb12n20+t2*t3*abb12n18+t2*t4*abb12n5+t2*t5*abb12n21)

      numerator = cmplx(real(d12, ki), aimag(d12), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_udbar_neepbbbar_d12h2l1
